import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

export class PreDestroyAnnotation implements DecoratorHandler {
  public onMethodDecorator = <T>(clazz: Class, target: Object, propertyKey: PropertyType,
                                 descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void => {
    console.log('PreDestroy');
  }
}

export const PreDestroy = Decorator.create(PreDestroyAnnotation);

export default PreDestroy;
