import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

interface SingletonPouchRegistry {
  registerSingleton(pouch: any, qualifier?: PropertyType): void;
  getSingleton(qualifier: PropertyType, clazz?: ClassType): any;
  getSingletonByClass(clazz: ClassType, qualifier?: PropertyType): any;
  hasSingleton(qualifier: PropertyType, clazz?: ClassType): boolean;
  hasSingletonByClass(clazz: ClassType, qualifier?: PropertyType): boolean;
}

export default SingletonPouchRegistry;
